=== debian/changelog ===
mingw-ocaml (4.01.0~20140328-1build3) xenial; urgency=medium

  * Rebuild for new OCaml ABIs.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 12 Feb 2016 12:03:22 +0000

mingw-ocaml (4.01.0~20140328-1build2) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 12:47:15 +0000

mingw-ocaml (4.01.0~20140328-1build1) xenial; urgency=medium

  * No-change rebuild against ocaml 4.02.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Fri, 06 Nov 2015 10:54:53 -0600

mingw-ocaml (4.01.0~20140328-1) unstable; urgency=medium

  * Update to OCaml 4.01.0.
  * Fix ocaml-mingw-w64 dependencies.
  Closes: #736171

 -- Romain Beauxis <toots@rastageeks.org>  Mon, 27 Jan 2014 05:48:17 -0600
